Package org.apache.datasketches.common

# Class BoundsOnRatiosInSampledSets

java.lang.Object
org.apache.datasketches.common.BoundsOnRatiosInSampledSets

public final class BoundsOnRatiosInSampledSets extends Object
This class is used to compute the bounds on the estimate of the ratio |B| / |A|, where:

- |A| is the unknown size of a set A of unique identifiers.
- |B| is the unknown size of a subset B of A.
- a = |SA| is the observed size of a sample of A that was obtained by Bernoulli sampling with a known inclusion probability f.
- b = |SA ∩ B| is the observed size of a subset of SA.

Author:
  Kevin Lang

## Method Summary

Modifier and Type
Method
Description
`static double`
`getEstimateOfA(long a, double f)`
Return the estimate of A.
`static double`
`getEstimateOfB(long b, double f)`
Return the estimate of B.
`static double`
`getEstimateOfBoverA(long a, long b)`
Return the estimate of b over a
`static double`
`getLowerBoundForBoverA(long a, long b, double f)`
Return the approximate lower bound based on a 95% confidence interval
`static double`
`getUpperBoundForBoverA(long a, long b, double f)`
Return the approximate upper bound based on a 95% confidence interval

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getLowerBoundForBoverA

public static double getLowerBoundForBoverA(long a, long b, double f)
Return the approximate lower bound based on a 95% confidence interval

Parameters:
  `a` - See class javadoc
  `b` - See class javadoc
  `f` - the inclusion probability used to produce the set with size a and should generally be less than 0.5. Above this value, the results not be reliable. When f = 1.0 this returns the estimate.
Returns:
  the approximate upper bound

### getUpperBoundForBoverA

public static double getUpperBoundForBoverA(long a, long b, double f)
Return the approximate upper bound based on a 95% confidence interval

Parameters:
  `a` - See class javadoc
  `b` - See class javadoc
  `f` - the inclusion probability used to produce the set with size a.
Returns:
  the approximate lower bound

### getEstimateOfBoverA

public static double getEstimateOfBoverA(long a, long b)
Return the estimate of b over a

Parameters:
  `a` - See class javadoc
  `b` - See class javadoc
Returns:
  the estimate of b over a

### getEstimateOfA

public static double getEstimateOfA(long a, double f)
Return the estimate of A. See class javadoc.

Parameters:
  `a` - See class javadoc
  `f` - the inclusion probability used to produce the set with size a.
Returns:
  the approximate lower bound

### getEstimateOfB

public static double getEstimateOfB(long b, double f)
Return the estimate of B. See class javadoc.

Parameters:
  `b` - See class javadoc
  `f` - the inclusion probability used to produce the set with size b.
Returns:
  the approximate lower bound